#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <sys/stat.h>            
#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include "motif.h"

#define OK      1
#define CANCEL  2

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;
Widget toplevel, form,menu_bar,file_menu,tools_menu;
Widget open_b,close_b,save_b,quit_b, search_b,jumpto_b;
Widget dialog1,text,jump_dial,search_dial,save_dial,err_dial,err2_dial;
Widget saveas_b,searcha_b,search_err,search_l,replac_l,search_f,repl_f;
Widget rep_dial,find_b,repl_b,search_menu,edit_b,dialog2,finderr;
int saved,founded;
char *file_name,*last_search;

void open_file(char *filename)
{
   int ac;
   Arg a1[10];
   char *s1,*s2;
   struct stat statb;
   FILE *fp;
      if (stat(filename, &statb)== -1 || 
         (statb.st_mode & S_IFMT) !=S_IFREG || !(fp=fopen(filename,"r"))) {
          if ((statb.st_mode & S_IFMT) == S_IFREG)
               perror(filename);  /* send to stderr why we can't read */
          else 
            fprintf(stderr, "%s: not a regular file\n",filename);
          XtFree(filename);
          return;
      }
      if (!(s1=XtMalloc((unsigned)(statb.st_size+1)))) {
         fprintf(stderr, "Can't alloc enough space for %s", filename);
         XtFree(filename);
         fclose(fp);
         return;
       }
       if (!fread(s1, sizeof(char), statb.st_size+1,fp))
          fprintf(stderr, "Warning: may not have read entire file!\n");
       s1[statb.st_size]=0;  /* be sure to NULL-terminate */
       XmTextSetString(text, s1);
       ac=0;  
       s2=(char *) malloc(strlen(filename) + 10);
       sprintf(s2,"BROWSE - %s",filename);
       XtSetArg(a1[ac],XmNtitle,s2);ac++;
       XtSetValues(toplevel,a1,ac);
       XtFree(s1);
       free(s2);
       saved=1;
       fclose(fp);
}

void write_file(char *file)
{
    FILE *f;
    char *s;
          if ((f=fopen(file,"w"))!=NULL)
         {
             /* get string from text widget */
             s = (char *)XmTextGetString(text);

             if (s!=NULL)
             {
              /* write the file */
              fwrite(s,sizeof(char),strlen(s),f);

    /* make sure last line terminated by '\n' so that vi,compilers like it */
              if (s[strlen(s)-1]!='\n')
              fprintf(f,"\n");
              XtFree(s);
             }
          fflush(f);
          fclose(f);
          saved=1;
         }
}
void save_cb(Widget w,int client_data,XmSelectionBoxCallbackStruct *call_data)
{
    char *n;

   switch (client_data)
   {
       case OK:
          XmStringGetLtoR(call_data->value,char_set,&n);
         write_file(n);
         if (file_name!=NULL) 
         free(file_name);
         file_name=(char *) malloc(strlen(n));
         strcpy(file_name,n);
         XtFree(n);
         break;
      case CANCEL:
         break;
   }
   XtUnmanageChild(w);
}

void jump_line(int num)
{
   int x,val,cur;
   char *s1;

   s1= (char *)XmTextGetString(text);
   x=0;
   cur=1;
   val=strlen(s1);
   while ((x<val)&&(cur<num))
      if (s1[x++]=='\n') cur++;
   XmTextSetInsertionPosition(text,(XmTextPosition)x);
    /* prevent memory leaks */
   if (s1 != NULL)
     XtFree(s1);
}

void searcherr_cb(Widget w,int client_data, XmAnyCallbackStruct *call_data)
{
   switch (client_data){
     case OK:XtSetSensitive(searcha_b,False);
             break;
   }
   XtUnmanageChild(w);
}

void reperr_cb(Widget w,int client_data, XmAnyCallbackStruct *call_data)
{
   switch (client_data){
     case OK:break;
   }
   XtUnmanageChild(w);
}
void finderr_cb(Widget w,int client_data, XmAnyCallbackStruct *call_data)
{
   switch (client_data){
     case OK:break;
   }
   XtUnmanageChild(w);
}
void search_line(char *str,int i)
{
   int pos,found,c,val;
   char *s1,*tmp,*s2;
   s1=(char *)XmTextGetString(text);
   val=strlen(str);
   s2=(char *)malloc(strlen(str)); 
   if ((i<0) || (i>strlen(s1)))
   {
      XtFree(s1);
      return;
   }
   else{
     tmp=(char *) XmTextGetString(text);
     pos=strlen(s1)-strlen(str)+1;
     strcpy(tmp,s1);
     for(c=0;c<i;c++)
       tmp++;
     strncpy(s2,tmp,strlen(str));
     found=0;
     while(i<pos)
     {
       if (strncasecmp(str,s2,strlen(str))==0)
       {
           found=1;
           break;
       }
       tmp++;
       strncpy(s2,tmp,strlen(str));
       i++;
     }
     if ((found==1)&&(i<strlen(s1))){ 
       founded=1;
       XmTextSetInsertionPosition(text,(XmTextPosition) i);
       XmTextSetHighlight(text,(XmTextPosition)0,(XmTextPosition) strlen(s1),
                           XmHIGHLIGHT_NORMAL);
       XmTextSetHighlight(text, (XmTextPosition) i, 
            (XmTextPosition) i + val,XmHIGHLIGHT_SELECTED);
     }else
     {
       founded=0;
       XtManageChild(search_err);
     }
     XtFree(s1);
     if (tmp!=NULL){
     for (c=i;c>0;c--)
       tmp--;
     XtFree(tmp); }
    if(s2!=NULL){ 
     free(s2); }
   }
}
void jump_cb(Widget w, int client_data, XmSelectionBoxCallbackStruct *call_data)
{
    char *str;
     switch(client_data){
       case OK:
               XmStringGetLtoR(call_data->value, char_set,&str);
               jump_line(atoi(str));
               XtFree(str);
               XtUnmanageChild(jump_dial);
               break;
       case CANCEL:XtUnmanageChild(jump_dial);
                   break;
     }
}

void search_cb(Widget w, int client_data, XmSelectionBoxCallbackStruct
                    *call_data)
{
   char *str;
   int val;
   switch(client_data) {
      case OK:
              XmStringGetLtoR(call_data->value, char_set, &str);
              val= (int) XmTextGetInsertionPosition(text);
              if (last_search!=NULL)
                free(last_search);
              last_search=(char *) malloc(strlen(str));
              strcpy(last_search,str);
              XtSetSensitive(searcha_b,True);
              search_line(str,val);
              XtFree(str);
              XtUnmanageChild(search_dial);
              break;
      case CANCEL:XtUnmanageChild(search_dial);
                  break;
     }
}

void save_file()
{
   if (file_name==NULL)
     XtManageChild(save_dial);
   else
     write_file(file_name);
}

void err_cb(Widget w,int client_data, XmAnyCallbackStruct *call_data)
{
   switch (client_data)
   {
       case OK:
         save_file();
         if (file_name!=NULL) free(file_name);
     if (last_search!=NULL) free(last_search);
         exit(0);
         break;
      case CANCEL:if (file_name!=NULL) free(file_name);     
           if (last_search!=NULL) free(last_search);
           exit(0);
         break;
   }
   XtUnmanageChild(w);
}
void err2_cb(Widget w,int client_data, XmAnyCallbackStruct *call_data)
{
   switch (client_data)
   {
       case OK:
         save_file();
         if (file_name!=NULL) free(file_name);
         XmTextSetString(text,NULL);
         break;
      case CANCEL:if (file_name!=NULL) free(file_name);
        XmTextSetString(text,NULL);
         break;
   }
     if (last_search!=NULL) free(last_search);
      XtSetSensitive(searcha_b,False);         
   XtUnmanageChild(w);
}
void close_cb()
{
   if (saved==1){
     if (file_name!=NULL) free(file_name);
     XmTextSetString(text,NULL);
     if (last_search!=NULL) free(last_search);
      XtSetSensitive(searcha_b,False);
   }
   else if (saved==0) XtManageChild(err2_dial);
  
}

void quit_cb()
{
   if (saved==1){
     if (file_name!=NULL) free(file_name);
     if (last_search!=NULL) free(last_search);
     exit(0);
   }
   else if (saved==0) XtManageChild(err_dial);
  
}
void file_cb(Widget w,int client_data, XmAnyCallbackStruct *call_data)
{
   switch(client_data)
   {
      case 1:XtManageChild(dialog1);break;
      case 2:close_cb();break;
      case 3:save_file();break;
      case 4:XtManageChild(save_dial);break;
      case 5:quit_cb();break;
   }

}

void searchm_cb(Widget w,int client_data, XmAnyCallbackStruct *call_data)
{
   int val;
   switch(client_data)
   {
      case 1:XtManageChild(search_dial);break;
      case 2:if (last_search!=NULL){              
              val= (int) XmTextGetInsertionPosition(text) +1;
              search_line(last_search,val);
              }else XtManageChild(search_dial);
              break;
      case 3:XtManageChild(jump_dial);break;
   }

}

void tools_cb(Widget w,int client_data, XmAnyCallbackStruct *call_data)
{
    switch(client_data){
      case 1:XtManageChild(dialog2);break;
    }
}
void open_cb(Widget w,int client_data,XmSelectionBoxCallbackStruct *call_data)
{
   char *filename;
   switch (client_data)
   {
      case OK:
                /* get the string from call_data */
                XmStringGetLtoR(call_data->value,char_set,&filename);
                open_file(filename);
                if (file_name!=NULL)
                  free(file_name);
                 file_name=(char *) malloc(strlen(filename));
                 strcpy(file_name,filename);  
                 XtFree(filename);
          break;
      case CANCEL:
                break;

   }
   XtUnmanageChild(w);

}
void text_cb(Widget w,int client_data,XmAnyCallbackStruct *call_data)
{
   switch(client_data)
   {
     case XmCR_VALUE_CHANGED:saved=0;break;
   }
}
void find_cb(Widget w,int client_data,XmPushButtonCallbackStruct *call_data)
{
   char *str;
   int val;
   switch(client_data)
   {
     case XmCR_ACTIVATE:
              str=XmTextFieldGetString(search_f);
              if((strcmp(str,""))!=0){
              val= (int) XmTextGetInsertionPosition(text);
              if (last_search!=NULL)
                free(last_search);
              last_search=(char *) malloc(strlen(str));
              strcpy(last_search,str);
              XtSetSensitive(searcha_b,True);
              search_line(str,val);
              XtFree(str);
              }else XtManageChild(finderr);
              break;
   }
}
void mopen_cb(Widget w,int client_data,XmSelectionBoxCallbackStruct *call_data)
{
   char *filename,*s1;
   switch (client_data)
   {
      case OK:
                /* get the string from call_data */
                XmStringGetLtoR(call_data->value,char_set,&filename);
                s1=(char *)malloc(44+strlen(filename));
       sprintf(s1,"/afs/unity/users/s/stephen/src/c++/browse %s &",filename);
                 system(s1);
                 free(s1); 
                 XtFree(filename);
          break;
      case CANCEL:
                break;

   }
   XtUnmanageChild(w);

}


void replace_cb(Widget w,int client_data,XmPushButtonCallbackStruct *call_data)
{
   char *str;
   int val;
   switch(client_data)
   {
     case XmCR_ACTIVATE:if (founded==1){
               str=XmTextFieldGetString(repl_f);
               val= (int) XmTextGetInsertionPosition(text);
               XmTextReplace(text,(XmTextPosition)val,
                 (XmTextPosition) (val + strlen(last_search)),str);
               XtFree(str);
               }else XtManageChild(rep_dial);
               break;
   }
}
void widget_maker()
{
   Arg a1[10];
   int ac;
   ac=0;
   /* create form to hold other widgets */
   form=new_form("form",toplevel);

   /* Create a menu bar */
   menu_bar=new_menubar("menu_bar",form);
   file_menu=design_menu("File",menu_bar);
   search_menu=design_menu("Search...",menu_bar);
   tools_menu=design_menu("Tools",menu_bar); 
   text=new_text("text",form);
   XtSetArg(a1[ac],XmNeditMode,XmMULTI_LINE_EDIT);ac++;
   XtSetValues(text,a1,ac);
   dialog1=file_dial("dialog1",toplevel);
   jump_dial=prompt_dial("Jump message", "Jump to Line: ",toplevel,jump_cb);
   search_dial=prompt_dial("Search message", "Search for string: " ,
       toplevel,search_cb);
   save_dial=file_dial("save_dial",toplevel);
   err_dial=message_box("err_dialog","File not saved!  Save now?",toplevel);
   err2_dial=message_box("err2_dialog","File not saved!  Save now?",toplevel);
   search_err=message_box("Search_err_dialog","String not found to end of file!",toplevel);
   XtUnmanageChild(XmMessageBoxGetChild(search_err,XmDIALOG_CANCEL_BUTTON));
   search_l=new_label("Find:  ",form);
   replac_l=new_label("Replace:   ",form);
   search_f=new_field("Search_field",form);
   repl_f=new_field("Replace_field",form);
   XmTextFieldSetString(search_f,"");
   XmTextFieldSetString(repl_f,"");
   rep_dial=message_box("Replace_dialog","Must use Find/Search before Replacing!",toplevel);
   XtUnmanageChild(XmMessageBoxGetChild(rep_dial,XmDIALOG_CANCEL_BUTTON));
   find_b=new_button("Find",form);
   repl_b=new_button("Replace",form);
   dialog2=file_dial("dialog2",toplevel);
   finderr=message_box("Find_dialog","Must enter something to Search for!",toplevel);
   XtUnmanageChild(XmMessageBoxGetChild(finderr,XmDIALOG_CANCEL_BUTTON));
}

void callb_maker()
{
   XtAddCallback(text,XmNvalueChangedCallback,text_cb,XmCR_VALUE_CHANGED);
   XtAddCallback(dialog1,XmNokCallback,open_cb,OK);
   XtAddCallback(dialog1,XmNcancelCallback,open_cb,CANCEL);
   XtAddCallback(save_dial,XmNokCallback,save_cb,OK);
   XtAddCallback(save_dial,XmNcancelCallback,save_cb,CANCEL);
   XtAddCallback(err_dial,XmNokCallback,err_cb,OK);
   XtAddCallback(err_dial,XmNcancelCallback,err_cb,CANCEL);
   XtAddCallback(err_dial,XmNokCallback,err2_cb,OK);
   XtAddCallback(err_dial,XmNcancelCallback,err2_cb,CANCEL);
   XtAddCallback(search_err,XmNokCallback,searcherr_cb,OK);
   XtAddCallback(find_b,XmNactivateCallback,find_cb,XmCR_ACTIVATE);
   XtAddCallback(repl_b,XmNactivateCallback,replace_cb,XmCR_ACTIVATE);
   XtAddCallback(finderr,XmNokCallback,finderr_cb,OK);
   XtAddCallback(rep_dial,XmNokCallback,reperr_cb,OK);
   XtAddCallback(dialog2,XmNokCallback,mopen_cb,OK);
   XtAddCallback(dialog2,XmNcancelCallback,mopen_cb,CANCEL);
}
void menub_maker()
{
   open_b=menu_item("Open",1,file_menu,file_cb);
   close_b=menu_item("Close",2,file_menu,file_cb);
   save_b=menu_item("Save",3,file_menu,file_cb);
   saveas_b=menu_item("Save As...",4,file_menu,file_cb);
   quit_b=menu_item("Quit",5,file_menu,file_cb);
   search_b=menu_item("Search",1,search_menu,searchm_cb);
   searcha_b=menu_item("Search again",2,search_menu,searchm_cb);
   XtSetSensitive(searcha_b,False);
   jumpto_b=menu_item("Jump to line...",3,search_menu,searchm_cb);
   edit_b=menu_item("Edit existing Makefile",1,tools_menu,tools_cb);
}
main(argc,argv)
  int argc;
  char *argv[];
{
   Arg a1[10];
   int ac;
   saved=0;
   /* Create the toplevel shell */
   toplevel=XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

   /* resize toplevel */
   ac=0;
   XtSetArg(a1[ac],XmNheight,400);ac++;
   XtSetArg(a1[ac],XmNwidth,650);ac++;
   XtSetValues(toplevel,a1,ac);

   /* create form to hold other widgets */
   widget_maker();
   callb_maker();
   menub_maker();
  
   ac=0;
   XtSetArg(a1[ac],XmNtopAttachment,XmATTACH_FORM);ac++;
   XtSetArg(a1[ac],XmNleftAttachment,XmATTACH_FORM);ac++;
   XtSetArg(a1[ac],XmNrightAttachment,XmATTACH_FORM);ac++;
   XtSetValues(menu_bar,a1,ac);

XtVaSetValues(search_l,XmNtopAttachment,XmATTACH_WIDGET,XmNtopWidget,
              menu_bar,XmNleftAttachment,XmATTACH_FORM,XmNrightAttachment,
              XmATTACH_POSITION,XmNrightPosition,10,NULL);

XtVaSetValues(search_f,XmNtopAttachment,XmATTACH_WIDGET,XmNtopWidget,
              menu_bar,XmNleftAttachment,XmATTACH_WIDGET,XmNleftWidget,
              search_l,XmNrightAttachment,XmATTACH_POSITION,
              XmNrightPosition,35,NULL);

XtVaSetValues(find_b,XmNtopAttachment,XmATTACH_WIDGET,XmNtopWidget,menu_bar,
              XmNleftAttachment,XmATTACH_POSITION,XmNleftPosition,36,
              XmNrightAttachment,XmATTACH_POSITION,XmNrightPosition,45,NULL);

XtVaSetValues(replac_l,XmNtopAttachment,XmATTACH_WIDGET,XmNtopWidget,
              menu_bar,XmNleftAttachment,XmATTACH_POSITION,XmNleftPosition,
              45,XmNrightAttachment,XmATTACH_POSITION,
              XmNrightPosition,56,NULL);

XtVaSetValues(repl_f,XmNtopAttachment,XmATTACH_WIDGET,XmNtopWidget,
              menu_bar,XmNleftAttachment,XmATTACH_WIDGET,XmNleftWidget,
         replac_l,XmNrightAttachment,XmATTACH_POSITION,XmNrightPosition,81,
          NULL);

XtVaSetValues(repl_b,XmNtopAttachment,XmATTACH_WIDGET,XmNtopWidget,menu_bar,
              XmNleftAttachment,XmATTACH_POSITION,XmNleftPosition,82,
              XmNrightAttachment,XmATTACH_POSITION,XmNrightPosition,92,NULL);

   XtVaSetValues(XtParent(text),XmNtopAttachment,XmATTACH_POSITION,
                 XmNtopPosition,17,XmNleftAttachment,XmATTACH_FORM,
           XmNrightAttachment,XmATTACH_FORM,XmNbottomAttachment,
           XmATTACH_POSITION,XmNbottomPosition,100,NULL);

  XmTextSetEditable(text,True);
  if (argc>1){
   file_name= (char *) malloc (strlen(argv[1]));
   strcpy(file_name,argv[1]);
   open_file(file_name);
   }
   else file_name=NULL;
   XtRealizeWidget(toplevel);
   XtAppMainLoop(context);
}

